import { CostExplorerServiceException as __BaseException } from "./CostExplorerServiceException";
export var AccountScope;
(function (AccountScope) {
    AccountScope["LINKED"] = "LINKED";
    AccountScope["PAYER"] = "PAYER";
})(AccountScope || (AccountScope = {}));
export var AnomalyFeedbackType;
(function (AnomalyFeedbackType) {
    AnomalyFeedbackType["NO"] = "NO";
    AnomalyFeedbackType["PLANNED_ACTIVITY"] = "PLANNED_ACTIVITY";
    AnomalyFeedbackType["YES"] = "YES";
})(AnomalyFeedbackType || (AnomalyFeedbackType = {}));
export var MonitorDimension;
(function (MonitorDimension) {
    MonitorDimension["SERVICE"] = "SERVICE";
})(MonitorDimension || (MonitorDimension = {}));
export var MatchOption;
(function (MatchOption) {
    MatchOption["ABSENT"] = "ABSENT";
    MatchOption["CASE_INSENSITIVE"] = "CASE_INSENSITIVE";
    MatchOption["CASE_SENSITIVE"] = "CASE_SENSITIVE";
    MatchOption["CONTAINS"] = "CONTAINS";
    MatchOption["ENDS_WITH"] = "ENDS_WITH";
    MatchOption["EQUALS"] = "EQUALS";
    MatchOption["GREATER_THAN_OR_EQUAL"] = "GREATER_THAN_OR_EQUAL";
    MatchOption["STARTS_WITH"] = "STARTS_WITH";
})(MatchOption || (MatchOption = {}));
export var Dimension;
(function (Dimension) {
    Dimension["AGREEMENT_END_DATE_TIME_AFTER"] = "AGREEMENT_END_DATE_TIME_AFTER";
    Dimension["AGREEMENT_END_DATE_TIME_BEFORE"] = "AGREEMENT_END_DATE_TIME_BEFORE";
    Dimension["ANOMALY_TOTAL_IMPACT_ABSOLUTE"] = "ANOMALY_TOTAL_IMPACT_ABSOLUTE";
    Dimension["ANOMALY_TOTAL_IMPACT_PERCENTAGE"] = "ANOMALY_TOTAL_IMPACT_PERCENTAGE";
    Dimension["AZ"] = "AZ";
    Dimension["BILLING_ENTITY"] = "BILLING_ENTITY";
    Dimension["CACHE_ENGINE"] = "CACHE_ENGINE";
    Dimension["DATABASE_ENGINE"] = "DATABASE_ENGINE";
    Dimension["DEPLOYMENT_OPTION"] = "DEPLOYMENT_OPTION";
    Dimension["INSTANCE_TYPE"] = "INSTANCE_TYPE";
    Dimension["INSTANCE_TYPE_FAMILY"] = "INSTANCE_TYPE_FAMILY";
    Dimension["INVOICING_ENTITY"] = "INVOICING_ENTITY";
    Dimension["LEGAL_ENTITY_NAME"] = "LEGAL_ENTITY_NAME";
    Dimension["LINKED_ACCOUNT"] = "LINKED_ACCOUNT";
    Dimension["LINKED_ACCOUNT_NAME"] = "LINKED_ACCOUNT_NAME";
    Dimension["OPERATING_SYSTEM"] = "OPERATING_SYSTEM";
    Dimension["OPERATION"] = "OPERATION";
    Dimension["PAYMENT_OPTION"] = "PAYMENT_OPTION";
    Dimension["PLATFORM"] = "PLATFORM";
    Dimension["PURCHASE_TYPE"] = "PURCHASE_TYPE";
    Dimension["RECORD_TYPE"] = "RECORD_TYPE";
    Dimension["REGION"] = "REGION";
    Dimension["RESERVATION_ID"] = "RESERVATION_ID";
    Dimension["RESOURCE_ID"] = "RESOURCE_ID";
    Dimension["RIGHTSIZING_TYPE"] = "RIGHTSIZING_TYPE";
    Dimension["SAVINGS_PLANS_TYPE"] = "SAVINGS_PLANS_TYPE";
    Dimension["SAVINGS_PLAN_ARN"] = "SAVINGS_PLAN_ARN";
    Dimension["SCOPE"] = "SCOPE";
    Dimension["SERVICE"] = "SERVICE";
    Dimension["SERVICE_CODE"] = "SERVICE_CODE";
    Dimension["SUBSCRIPTION_ID"] = "SUBSCRIPTION_ID";
    Dimension["TENANCY"] = "TENANCY";
    Dimension["USAGE_TYPE"] = "USAGE_TYPE";
    Dimension["USAGE_TYPE_GROUP"] = "USAGE_TYPE_GROUP";
})(Dimension || (Dimension = {}));
export var MonitorType;
(function (MonitorType) {
    MonitorType["CUSTOM"] = "CUSTOM";
    MonitorType["DIMENSIONAL"] = "DIMENSIONAL";
})(MonitorType || (MonitorType = {}));
export var AnomalySubscriptionFrequency;
(function (AnomalySubscriptionFrequency) {
    AnomalySubscriptionFrequency["DAILY"] = "DAILY";
    AnomalySubscriptionFrequency["IMMEDIATE"] = "IMMEDIATE";
    AnomalySubscriptionFrequency["WEEKLY"] = "WEEKLY";
})(AnomalySubscriptionFrequency || (AnomalySubscriptionFrequency = {}));
export var SubscriberStatus;
(function (SubscriberStatus) {
    SubscriberStatus["CONFIRMED"] = "CONFIRMED";
    SubscriberStatus["DECLINED"] = "DECLINED";
})(SubscriberStatus || (SubscriberStatus = {}));
export var SubscriberType;
(function (SubscriberType) {
    SubscriberType["EMAIL"] = "EMAIL";
    SubscriberType["SNS"] = "SNS";
})(SubscriberType || (SubscriberType = {}));
export class LimitExceededException extends __BaseException {
    constructor(opts) {
        super({
            name: "LimitExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "LimitExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, LimitExceededException.prototype);
        this.Message = opts.Message;
    }
}
export class UnknownMonitorException extends __BaseException {
    constructor(opts) {
        super({
            name: "UnknownMonitorException",
            $fault: "client",
            ...opts,
        });
        this.name = "UnknownMonitorException";
        this.$fault = "client";
        Object.setPrototypeOf(this, UnknownMonitorException.prototype);
        this.Message = opts.Message;
    }
}
export var CostCategoryInheritedValueDimensionName;
(function (CostCategoryInheritedValueDimensionName) {
    CostCategoryInheritedValueDimensionName["LINKED_ACCOUNT_NAME"] = "LINKED_ACCOUNT_NAME";
    CostCategoryInheritedValueDimensionName["TAG"] = "TAG";
})(CostCategoryInheritedValueDimensionName || (CostCategoryInheritedValueDimensionName = {}));
export var CostCategoryRuleType;
(function (CostCategoryRuleType) {
    CostCategoryRuleType["INHERITED_VALUE"] = "INHERITED_VALUE";
    CostCategoryRuleType["REGULAR"] = "REGULAR";
})(CostCategoryRuleType || (CostCategoryRuleType = {}));
export var CostCategoryRuleVersion;
(function (CostCategoryRuleVersion) {
    CostCategoryRuleVersion["CostCategoryExpressionV1"] = "CostCategoryExpression.v1";
})(CostCategoryRuleVersion || (CostCategoryRuleVersion = {}));
export var CostCategorySplitChargeMethod;
(function (CostCategorySplitChargeMethod) {
    CostCategorySplitChargeMethod["EVEN"] = "EVEN";
    CostCategorySplitChargeMethod["FIXED"] = "FIXED";
    CostCategorySplitChargeMethod["PROPORTIONAL"] = "PROPORTIONAL";
})(CostCategorySplitChargeMethod || (CostCategorySplitChargeMethod = {}));
export var CostCategorySplitChargeRuleParameterType;
(function (CostCategorySplitChargeRuleParameterType) {
    CostCategorySplitChargeRuleParameterType["ALLOCATION_PERCENTAGES"] = "ALLOCATION_PERCENTAGES";
})(CostCategorySplitChargeRuleParameterType || (CostCategorySplitChargeRuleParameterType = {}));
export class ServiceQuotaExceededException extends __BaseException {
    constructor(opts) {
        super({
            name: "ServiceQuotaExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "ServiceQuotaExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ServiceQuotaExceededException.prototype);
        this.Message = opts.Message;
    }
}
export class UnknownSubscriptionException extends __BaseException {
    constructor(opts) {
        super({
            name: "UnknownSubscriptionException",
            $fault: "client",
            ...opts,
        });
        this.name = "UnknownSubscriptionException";
        this.$fault = "client";
        Object.setPrototypeOf(this, UnknownSubscriptionException.prototype);
        this.Message = opts.Message;
    }
}
export class ResourceNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
        this.Message = opts.Message;
        this.ResourceName = opts.ResourceName;
    }
}
export var CostCategoryStatusComponent;
(function (CostCategoryStatusComponent) {
    CostCategoryStatusComponent["COST_EXPLORER"] = "COST_EXPLORER";
})(CostCategoryStatusComponent || (CostCategoryStatusComponent = {}));
export var CostCategoryStatus;
(function (CostCategoryStatus) {
    CostCategoryStatus["APPLIED"] = "APPLIED";
    CostCategoryStatus["PROCESSING"] = "PROCESSING";
})(CostCategoryStatus || (CostCategoryStatus = {}));
export var NumericOperator;
(function (NumericOperator) {
    NumericOperator["BETWEEN"] = "BETWEEN";
    NumericOperator["EQUAL"] = "EQUAL";
    NumericOperator["GREATER_THAN"] = "GREATER_THAN";
    NumericOperator["GREATER_THAN_OR_EQUAL"] = "GREATER_THAN_OR_EQUAL";
    NumericOperator["LESS_THAN"] = "LESS_THAN";
    NumericOperator["LESS_THAN_OR_EQUAL"] = "LESS_THAN_OR_EQUAL";
})(NumericOperator || (NumericOperator = {}));
export class InvalidNextTokenException extends __BaseException {
    constructor(opts) {
        super({
            name: "InvalidNextTokenException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidNextTokenException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidNextTokenException.prototype);
        this.Message = opts.Message;
    }
}
export class BillExpirationException extends __BaseException {
    constructor(opts) {
        super({
            name: "BillExpirationException",
            $fault: "client",
            ...opts,
        });
        this.name = "BillExpirationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, BillExpirationException.prototype);
        this.Message = opts.Message;
    }
}
export class DataUnavailableException extends __BaseException {
    constructor(opts) {
        super({
            name: "DataUnavailableException",
            $fault: "client",
            ...opts,
        });
        this.name = "DataUnavailableException";
        this.$fault = "client";
        Object.setPrototypeOf(this, DataUnavailableException.prototype);
        this.Message = opts.Message;
    }
}
export var Granularity;
(function (Granularity) {
    Granularity["DAILY"] = "DAILY";
    Granularity["HOURLY"] = "HOURLY";
    Granularity["MONTHLY"] = "MONTHLY";
})(Granularity || (Granularity = {}));
export var GroupDefinitionType;
(function (GroupDefinitionType) {
    GroupDefinitionType["COST_CATEGORY"] = "COST_CATEGORY";
    GroupDefinitionType["DIMENSION"] = "DIMENSION";
    GroupDefinitionType["TAG"] = "TAG";
})(GroupDefinitionType || (GroupDefinitionType = {}));
export class RequestChangedException extends __BaseException {
    constructor(opts) {
        super({
            name: "RequestChangedException",
            $fault: "client",
            ...opts,
        });
        this.name = "RequestChangedException";
        this.$fault = "client";
        Object.setPrototypeOf(this, RequestChangedException.prototype);
        this.Message = opts.Message;
    }
}
export var SortOrder;
(function (SortOrder) {
    SortOrder["ASCENDING"] = "ASCENDING";
    SortOrder["DESCENDING"] = "DESCENDING";
})(SortOrder || (SortOrder = {}));
export var Metric;
(function (Metric) {
    Metric["AMORTIZED_COST"] = "AMORTIZED_COST";
    Metric["BLENDED_COST"] = "BLENDED_COST";
    Metric["NET_AMORTIZED_COST"] = "NET_AMORTIZED_COST";
    Metric["NET_UNBLENDED_COST"] = "NET_UNBLENDED_COST";
    Metric["NORMALIZED_USAGE_AMOUNT"] = "NORMALIZED_USAGE_AMOUNT";
    Metric["UNBLENDED_COST"] = "UNBLENDED_COST";
    Metric["USAGE_QUANTITY"] = "USAGE_QUANTITY";
})(Metric || (Metric = {}));
export var Context;
(function (Context) {
    Context["COST_AND_USAGE"] = "COST_AND_USAGE";
    Context["RESERVATIONS"] = "RESERVATIONS";
    Context["SAVINGS_PLANS"] = "SAVINGS_PLANS";
})(Context || (Context = {}));
export var LookbackPeriodInDays;
(function (LookbackPeriodInDays) {
    LookbackPeriodInDays["SEVEN_DAYS"] = "SEVEN_DAYS";
    LookbackPeriodInDays["SIXTY_DAYS"] = "SIXTY_DAYS";
    LookbackPeriodInDays["THIRTY_DAYS"] = "THIRTY_DAYS";
})(LookbackPeriodInDays || (LookbackPeriodInDays = {}));
export var PaymentOption;
(function (PaymentOption) {
    PaymentOption["ALL_UPFRONT"] = "ALL_UPFRONT";
    PaymentOption["HEAVY_UTILIZATION"] = "HEAVY_UTILIZATION";
    PaymentOption["LIGHT_UTILIZATION"] = "LIGHT_UTILIZATION";
    PaymentOption["MEDIUM_UTILIZATION"] = "MEDIUM_UTILIZATION";
    PaymentOption["NO_UPFRONT"] = "NO_UPFRONT";
    PaymentOption["PARTIAL_UPFRONT"] = "PARTIAL_UPFRONT";
})(PaymentOption || (PaymentOption = {}));
export var OfferingClass;
(function (OfferingClass) {
    OfferingClass["CONVERTIBLE"] = "CONVERTIBLE";
    OfferingClass["STANDARD"] = "STANDARD";
})(OfferingClass || (OfferingClass = {}));
export var TermInYears;
(function (TermInYears) {
    TermInYears["ONE_YEAR"] = "ONE_YEAR";
    TermInYears["THREE_YEARS"] = "THREE_YEARS";
})(TermInYears || (TermInYears = {}));
export var RecommendationTarget;
(function (RecommendationTarget) {
    RecommendationTarget["CROSS_INSTANCE_FAMILY"] = "CROSS_INSTANCE_FAMILY";
    RecommendationTarget["SAME_INSTANCE_FAMILY"] = "SAME_INSTANCE_FAMILY";
})(RecommendationTarget || (RecommendationTarget = {}));
export var FindingReasonCode;
(function (FindingReasonCode) {
    FindingReasonCode["CPU_OVER_PROVISIONED"] = "CPU_OVER_PROVISIONED";
    FindingReasonCode["CPU_UNDER_PROVISIONED"] = "CPU_UNDER_PROVISIONED";
    FindingReasonCode["DISK_IOPS_OVER_PROVISIONED"] = "DISK_IOPS_OVER_PROVISIONED";
    FindingReasonCode["DISK_IOPS_UNDER_PROVISIONED"] = "DISK_IOPS_UNDER_PROVISIONED";
    FindingReasonCode["DISK_THROUGHPUT_OVER_PROVISIONED"] = "DISK_THROUGHPUT_OVER_PROVISIONED";
    FindingReasonCode["DISK_THROUGHPUT_UNDER_PROVISIONED"] = "DISK_THROUGHPUT_UNDER_PROVISIONED";
    FindingReasonCode["EBS_IOPS_OVER_PROVISIONED"] = "EBS_IOPS_OVER_PROVISIONED";
    FindingReasonCode["EBS_IOPS_UNDER_PROVISIONED"] = "EBS_IOPS_UNDER_PROVISIONED";
    FindingReasonCode["EBS_THROUGHPUT_OVER_PROVISIONED"] = "EBS_THROUGHPUT_OVER_PROVISIONED";
    FindingReasonCode["EBS_THROUGHPUT_UNDER_PROVISIONED"] = "EBS_THROUGHPUT_UNDER_PROVISIONED";
    FindingReasonCode["MEMORY_OVER_PROVISIONED"] = "MEMORY_OVER_PROVISIONED";
    FindingReasonCode["MEMORY_UNDER_PROVISIONED"] = "MEMORY_UNDER_PROVISIONED";
    FindingReasonCode["NETWORK_BANDWIDTH_OVER_PROVISIONED"] = "NETWORK_BANDWIDTH_OVER_PROVISIONED";
    FindingReasonCode["NETWORK_BANDWIDTH_UNDER_PROVISIONED"] = "NETWORK_BANDWIDTH_UNDER_PROVISIONED";
    FindingReasonCode["NETWORK_PPS_OVER_PROVISIONED"] = "NETWORK_PPS_OVER_PROVISIONED";
    FindingReasonCode["NETWORK_PPS_UNDER_PROVISIONED"] = "NETWORK_PPS_UNDER_PROVISIONED";
})(FindingReasonCode || (FindingReasonCode = {}));
export var PlatformDifference;
(function (PlatformDifference) {
    PlatformDifference["HYPERVISOR"] = "HYPERVISOR";
    PlatformDifference["INSTANCE_STORE_AVAILABILITY"] = "INSTANCE_STORE_AVAILABILITY";
    PlatformDifference["NETWORK_INTERFACE"] = "NETWORK_INTERFACE";
    PlatformDifference["STORAGE_INTERFACE"] = "STORAGE_INTERFACE";
    PlatformDifference["VIRTUALIZATION_TYPE"] = "VIRTUALIZATION_TYPE";
})(PlatformDifference || (PlatformDifference = {}));
export var RightsizingType;
(function (RightsizingType) {
    RightsizingType["MODIFY"] = "MODIFY";
    RightsizingType["TERMINATE"] = "TERMINATE";
})(RightsizingType || (RightsizingType = {}));
export var SupportedSavingsPlansType;
(function (SupportedSavingsPlansType) {
    SupportedSavingsPlansType["COMPUTE_SP"] = "COMPUTE_SP";
    SupportedSavingsPlansType["EC2_INSTANCE_SP"] = "EC2_INSTANCE_SP";
    SupportedSavingsPlansType["SAGEMAKER_SP"] = "SAGEMAKER_SP";
})(SupportedSavingsPlansType || (SupportedSavingsPlansType = {}));
export var SavingsPlansDataType;
(function (SavingsPlansDataType) {
    SavingsPlansDataType["AMORTIZED_COMMITMENT"] = "AMORTIZED_COMMITMENT";
    SavingsPlansDataType["ATTRIBUTES"] = "ATTRIBUTES";
    SavingsPlansDataType["SAVINGS"] = "SAVINGS";
    SavingsPlansDataType["UTILIZATION"] = "UTILIZATION";
})(SavingsPlansDataType || (SavingsPlansDataType = {}));
export class UnresolvableUsageUnitException extends __BaseException {
    constructor(opts) {
        super({
            name: "UnresolvableUsageUnitException",
            $fault: "client",
            ...opts,
        });
        this.name = "UnresolvableUsageUnitException";
        this.$fault = "client";
        Object.setPrototypeOf(this, UnresolvableUsageUnitException.prototype);
        this.Message = opts.Message;
    }
}
export var CostAllocationTagStatus;
(function (CostAllocationTagStatus) {
    CostAllocationTagStatus["ACTIVE"] = "Active";
    CostAllocationTagStatus["INACTIVE"] = "Inactive";
})(CostAllocationTagStatus || (CostAllocationTagStatus = {}));
export var CostAllocationTagType;
(function (CostAllocationTagType) {
    CostAllocationTagType["AWS_GENERATED"] = "AWSGenerated";
    CostAllocationTagType["USER_DEFINED"] = "UserDefined";
})(CostAllocationTagType || (CostAllocationTagType = {}));
export var GenerationStatus;
(function (GenerationStatus) {
    GenerationStatus["FAILED"] = "FAILED";
    GenerationStatus["PROCESSING"] = "PROCESSING";
    GenerationStatus["SUCCEEDED"] = "SUCCEEDED";
})(GenerationStatus || (GenerationStatus = {}));
export class GenerationExistsException extends __BaseException {
    constructor(opts) {
        super({
            name: "GenerationExistsException",
            $fault: "client",
            ...opts,
        });
        this.name = "GenerationExistsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, GenerationExistsException.prototype);
        this.Message = opts.Message;
    }
}
export class TooManyTagsException extends __BaseException {
    constructor(opts) {
        super({
            name: "TooManyTagsException",
            $fault: "client",
            ...opts,
        });
        this.name = "TooManyTagsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, TooManyTagsException.prototype);
        this.Message = opts.Message;
        this.ResourceName = opts.ResourceName;
    }
}
